import gtk

class ChartView(gtk.HPaned):

    results=[]

    def create_new_chart(self, allocation):
        import xnat_search_histogram
        import tempfile
        substrings = []
        strings = []
        for r in self.results:
            strings.append(r['type'])
        for sub in self.treeViewChartValues.store:
            if not sub[0] == self.treeViewChartValues.inital_value:
                substrings.append(sub[0])
        data = xnat_search_histogram.count_substrings(substrings, strings)
        with tempfile.NamedTemporaryFile(delete=True) as file:
            xnat_search_histogram.create(file,data,(allocation.width,allocation.height),len(self.results), len(self.treeViewChartValues.store)-1)
            file.flush()
            self.image.set_from_file(file.name)

    def update_chart(self, data):
        self.results = data
        self.create_new_chart(self.image.get_allocation())

    def __init__(self, *args, **kwargs):
        super(ChartView, self).__init__(*args, **kwargs)

        self.set_position(220)

        v_box = gtk.VBox()
        self.add1(v_box)

        sw_hist_values = gtk.ScrolledWindow()
        sw_hist_values.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        sw_hist_values.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        v_box.pack_start(sw_hist_values, True, True, 0)


        def callback_columns_changed(*_):
            self.create_new_chart(self.image.get_allocation())

        self.treeViewChartValues = treeViewChartValues()
        self.treeViewChartValues.connect("values-changed", callback_columns_changed)
        sw_hist_values.add(self.treeViewChartValues)

        hBox_type = gtk.HBox()
        v_box.pack_start(hBox_type, False, True, 0)

        label_type = gtk.Label()
        label_type.set_text("Type: ")
        hBox_type.pack_start(label_type, False, True, 0)

        comboBox = gtk.ComboBox()
        hBox_type.pack_start(comboBox, True, True,0)

        # chart

        frame_image = gtk.Frame()
        self.add2(frame_image)
        frame_image.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        self.image = gtk.Image()
        frame_image.add(self.image)

        from pydash import throttle

        def callback_char_size_allocate(widget, allocation, *_):
            if callback_char_size_allocate.old_allocation.width != allocation.width or callback_char_size_allocate.old_allocation.height != allocation.height:
                self.create_new_chart(allocation)
                callback_char_size_allocate.old_allocation = allocation

        callback_char_size_allocate = throttle(callback_char_size_allocate, 50)
        callback_char_size_allocate.old_allocation = gtk.gdk.Rectangle()

        self.image.connect("size-allocate",callback_char_size_allocate)



class treeViewChartValues(gtk.TreeView):

    inital_value = "..."
    tooltip = 'Delete by using right click'

    def __init__(self):
        super(treeViewChartValues, self).__init__()
        self.create_model()
        self.create_column()

        import gobject
        gobject.signal_new("values-changed", treeViewChartValues, gobject.SIGNAL_RUN_FIRST,
        gobject.TYPE_NONE, ())


        def on_treeview_button_press_event(treeview, event):
            if event.button == 3:
                x = int(event.x)
                y = int(event.y)
                path_info = treeview.get_path_at_pos(x, y)
                if path_info is not None:
                    path, col, cellx, celly = path_info
                    iter = self.store.get_iter(path)
                    if self.store.get_value(iter,0) != self.inital_value:
                        self.store.remove(iter)
            self.emit("values-changed")

        self.connect('button_press_event', on_treeview_button_press_event)
        self.set_tooltip_column(1)


    def create_column(self):

        def cell_edited_callback(cellrenderertext, path_string, new_text, *_):
            it = self.store.get_iter_from_string(path_string)
            it_last = self.store.get_iter(len(self.store)-1)
            self.store.set(it, 0, new_text)
            if not (it_last is None) and (self.store.get_value(it_last, 0) != self.inital_value):
                self.store.append([self.inital_value, self.tooltip])
            self.emit("values-changed")


        rendererText = gtk.CellRendererText()
        rendererText.set_property('editable', True)
        rendererText.connect('edited', cell_edited_callback, 2)

        column = gtk.TreeViewColumn("Chart Values (Type Substrings)", rendererText, text=0)
        column.set_sort_column_id(0)
        self.append_column(column)

    def create_model(self):
        self.store = gtk.ListStore(str, str)
        self.store.append([self.inital_value, self.tooltip])
        self.set_model(self.store)
